// Definice pinů pro tranzistory
int tranzistorPiny[] = {2, 3, 4, 5, 6, 7, 8, 9, 10, 11,12};
int pocetTranzistoru = 11;

// Pin pro potenciometr
int potenciometrPin = A0;

// Časový interval pro efekt hada (menší hodnota znamená rychlejší pohyb)
int interval = 100;

void setup() {
  // Nastavení všech pinů tranzistorů jako výstupních
  for (int i = 0; i < pocetTranzistoru; i++) {
    pinMode(tranzistorPiny[i], OUTPUT);
  }
}

void loop() {
  // Čtení hodnoty potenciometru
  int rychlost = analogRead(potenciometrPin);
  // Mapování hodnoty potenciometru na rozumný rozsah intervalu (např. 50 až 500)
  interval = map(rychlost, 0, 1023, 50, 500);

  // Efekt hada
  for (int i = 0; i < pocetTranzistoru; i++) {
    // Zapnout tranzistor
    digitalWrite(tranzistorPiny[i], HIGH);
    // Počkat na krátký interval
    delay(interval);
    // Vypnout tranzistor
    digitalWrite(tranzistorPiny[i], LOW);
  }

  // Posunout hodnoty v poli tranzistorů (jako efekt hada)
  int posun = tranzistorPiny[pocetTranzistoru - 1];
  for (int i = pocetTranzistoru - 1; i > 0; i--) {
    tranzistorPiny[i] = tranzistorPiny[i - 1];
  }
  tranzistorPiny[0] = posun;
}

